## mingw-w64-dosbox-0.80.1-1.src.tar.zst

=== meson_options.txt ===
option(
    'use_sdl2_net',
    type: 'boolean',
    value: true,
    description: 'Enable networking features via SDL2_net (modem, ipx)',
)

option(
    'use_sdl2_image',
    type: 'boolean',
    value: true,
    description: 'Enable screenshots of rendered output',
)

option(
    'use_opengl',
    type: 'combo',
    choices: ['auto', 'true', 'false'],
    value: 'auto',
    description: 'Enable OpenGL support',
)

option(
    'use_fluidsynth',
    type: 'boolean',
    value: true,
    description: 'Enable built-in MIDI support via FluidSynth',
)

option(
    'use_mt32emu',
    type: 'boolean',
    value: true,
    description: 'Enable built-in MT-32 emulation support',
)

option(
    'use_png',
    type: 'boolean',
    value: true,
    description: 'Enable saving screenshots in .png format',
)

option(
    'use_slirp',
    type: 'boolean',
    value: true,
    description: 'Enable Ethernet emulation using Libslirp',
)

option(
    'tracy',
    type: 'boolean',
    value: false,
    description: 'Enable profiling using Tracy',
)

# This option exists only for rare situations when Linux developer cannot
# install ALSA library headers on their machine.
#
# 'auto' translates to 'true' on Linux systems and 'false' everywhere else.
#
option(
    'use_alsa',
    type: 'combo',
    choices: ['auto', 'true', 'false'],
    value: 'auto',
    description: 'Enable ALSA MIDI support',
)

# This option lets packagers control whether ManyMouse uses the optional X Input
# 2.0 protocol. Because this requires a full X11 library stack, it's useful for
# distributions that either come with a full X11 environment (and want to make
# this a hard dependency), or for those without an X11 environment but may still
# have X11 in their build bots (and don't want this pulled in by accident).
#
option(
    'use_xinput2',
    type: 'combo',
    choices: ['auto', 'true', 'false'],
    value: 'auto',
    description: 'Let ManyMouse use the X Input 2.0 protocol.'
)

option(
    'enable_debugger',
    type: 'combo',
    choices: ['normal', 'heavy', 'none'],
    value: 'none',
    description: 'Build emulator with internal debugger feature.',
)

option(
    'dynamic_core',
    type: 'combo',
    choices: ['auto', 'dyn-x86', 'dynrec', 'none'],
    value: 'auto',
    description: 'Select the dynamic core implementation.',
)

# Use this option for selectively switching dependencies to look for static
# libraries first. This behaves differently than passing
# -Ddefault_library=static (which will turn on static linking for dependencies
# built from wraps, but still attempt dynamic linking for system-installed
# libraries).
#
# This is NOT guaranteed to work - the end results will vary depending on your
# OS, installed libraries, and dependencies of those libraries.
#
option(
    'try_static_libs',
    type: 'array',
    choices: [
        'fluidsynth',
        'glib',
        'iir',
        'mt32emu',
        'opusfile',
        'png',
        'sdl2',
        'sdl2_image',
        'sdl2_net',
        'slirp',
        'speexdsp',
        'tracy',
        'zlib',
    ],
    value: [],
    description: 'Attempt to statically link selected libraries.',
)

option(
    'unit_tests',
    type: 'feature',
    value: 'auto',
    description: 'Build unit tests. Auto skips for release builds.',
)

option(
    'narrowing_warnings',
    type: 'boolean',
    value: false,
    description: 'Warn about implicit type narrowing',
)

option(
    'autovec_info',
    type: 'boolean',
    value: false,
    description: 'Inform about auto-vectorizion results',
)

option(
    'asm',
    type: 'boolean',
    value: false,
    description: 'Save intermediate assembly output',
)

=== contrib/icons/Makefile ===
.PHONY: help clean favicons

help:
	@echo "Re-generate icons in platform specific formats or install pre-rendered png icons"
	@echo ""
	@echo "Usage:"
	@echo "  make install             # install icons to \$${DESTDIR}/usr/local/share/icons/..."
	@echo "  make install prefix=/usr # install icons to \$${DESTDIR}/usr/share/icons/..."
	@echo "  make install datadir=foo # install icons to \$${DESTDIR}foo/icons/..."
	@echo ""
	@echo "Other available targets:"
	@echo "  hicolor             - generate freedesktop.org icon directory structure"
	@echo "  dosbox-staging.ico  - Windows format"
	@echo "  dosbox-staging.icns - macOS format"
	@echo "  icon_<size>.png     - render icon in specific size, e.g. icon_24.png"
	@echo "  clean               - clean intermediate files"

##
#  Create an icon using Windows .ico format.
#
#  Windows users are expected to create icons using GUI applications, and
#  there's no good Windows-native command line program for this usecase.
#
#  This target is using icotool (package icoutils) to create an .ico file.
#  Uses librsvg for rendering vectors (package available in most repos).
#
dosbox-staging.ico: \
		icon_256.png \
		icon_48.png \
		icon_32.png \
		icon_24.png \
		icon_16.png
	icotool -c $^ -o $@

##
# Favicons for a web page. Usage:
#
# <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
# <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
# <link rel="icon" type="image/png" sizes="96x96" href="/favicon-96x96.png">
#
favicons: \
		favicon-16x16.png \
		favicon-32x32.png \
		favicon-96x96.png

##
#  Create an icon using macOS .icns format.
#
#  iconutil is avaliable on macOS out of the box.
#  Uses librsvg for rendering vectors (package available via brew).
#
dosbox-staging.icns: dosbox-staging.iconset
	iconutil -c icns dosbox-staging.iconset

dosbox-staging.iconset: \
		icon_1024.png \
		icon_512.png \
		icon_256.png \
		icon_128.png \
		icon_64.png \
		icon_32.png \
		icon_16.png
	mkdir -p "$@"
	cp icon_16.png   $@/icon_16x16.png
	cp icon_32.png   $@/icon_16x16@2x.png
	cp icon_32.png   $@/icon_32x32.png
	cp icon_64.png   $@/icon_32x32@2x.png
	cp icon_128.png  $@/icon_128x128.png
	cp icon_256.png  $@/icon_128x128@2x.png
	cp icon_256.png  $@/icon_256x256.png
	cp icon_512.png  $@/icon_256x256@2x.png
	cp icon_512.png  $@/icon_512x512.png
	cp icon_1024.png $@/icon_512x512@2x.png

##
# Freedesktop icons (for Linux or other OSes) often are placed in 'hicolor'
# directory in /usr/share/icons/ or /usr/local/share/icons/.
#
# Users can override them by placing icons in ~/.local/share/icons/
#
# This is not strictly necessary (just placing scalable icon is enough,
# but some there are some corner cases where small raster icon looks better).
#
hicolor: \
		dosbox-staging.svg \
		icon_32.png \
		icon_24.png \
		icon_22.png \
		icon_16.png
	install -DT -m 644 $<          $@/scalable/apps/dosbox-staging.svg
	install -DT -m 644 icon_32.png $@/32x32/apps/dosbox-staging.png
	install -DT -m 644 icon_24.png $@/24x24/apps/dosbox-staging.png
	install -DT -m 644 icon_22.png $@/22x22/apps/dosbox-staging.png
	install -DT -m 644 icon_16.png $@/16x16/apps/dosbox-staging.png

icon_16.png: small-svg/dosbox-staging-16.svg
	rsvg-convert -h 16 $< > $@

icon_24.png: small-svg/dosbox-staging-24.svg
	rsvg-convert -h 24 $< > $@

# Some desktop environments expect 22x22 icon (e.g. KDE Plasma).
# Rendering 24px source to 22px looks good enough.
icon_22.png: small-svg/dosbox-staging-24.svg
	rsvg-convert -h 22 $< > $@

icon_32.png: small-svg/dosbox-staging-32.svg
	rsvg-convert -h 32 $< > $@

icon_48.png: dosbox-staging.svg
	rsvg-convert -h 48 $< > $@

icon_64.png: dosbox-staging.svg
	rsvg-convert -h 64 $< > $@

icon_96.png: dosbox-staging.svg
	rsvg-convert -h 96 $< > $@

icon_128.png: dosbox-staging.svg
	rsvg-convert -h 128 $< > $@

icon_256.png: dosbox-staging.svg
	rsvg-convert -h 256 $< > $@

icon_512.png: dosbox-staging.svg
	rsvg-convert -h 512 $< > $@

icon_1024.png: dosbox-staging.svg
	rsvg-convert -h 1024 $< > $@

favicon-16x16.png: icon_16.png
	cp $< $@

favicon-32x32.png: icon_32.png
	cp $< $@

favicon-96x96.png: icon_96.png
	cp $< $@

prefix = /usr/local
datadir = $(prefix)/share
install:
	install -p -m 0644 -Dt "$(DESTDIR)$(datadir)/icons/hicolor/16x16/apps" small-png/16x16/dosbox-staging.png
	install -p -m 0644 -Dt "$(DESTDIR)$(datadir)/icons/hicolor/22x22/apps" small-png/22x22/dosbox-staging.png
	install -p -m 0644 -Dt "$(DESTDIR)$(datadir)/icons/hicolor/24x24/apps" small-png/24x24/dosbox-staging.png
	install -p -m 0644 -Dt "$(DESTDIR)$(datadir)/icons/hicolor/32x32/apps" small-png/32x32/dosbox-staging.png
	install -p -m 0644 -Dt "$(DESTDIR)$(datadir)/icons/hicolor/scalable/apps" dosbox-staging.svg

clean:
	rm -rf dosbox-staging.iconset
	rm -rf hicolor
	rm -f icon_*.png
	rm -f favicon*

=== PKGBUILD ===
# Maintainer: Christoph Reiter <reiter.christoph@gmail.com>

_realname=dosbox
_forkname=dosbox-staging
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.80.1
pkgrel=1
pkgdesc="Emulator with builtin DOS for running DOS Games (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32')
url='https://github.com/dosbox-staging/dosbox-staging'
license=('spdx:GPL-2.0-or-later')
depends=(
    "${MINGW_PACKAGE_PREFIX}-fluidsynth"
    "${MINGW_PACKAGE_PREFIX}-libpng"
    "${MINGW_PACKAGE_PREFIX}-opusfile"
    "${MINGW_PACKAGE_PREFIX}-SDL2"
    "${MINGW_PACKAGE_PREFIX}-SDL2_image"
    "${MINGW_PACKAGE_PREFIX}-SDL2_net"
    "${MINGW_PACKAGE_PREFIX}-zlib"
    "${MINGW_PACKAGE_PREFIX}-libslirp"
    "${MINGW_PACKAGE_PREFIX}-munt-mt32emu"
    "${MINGW_PACKAGE_PREFIX}-speexdsp"
    "${MINGW_PACKAGE_PREFIX}-iir"
)
makedepends=("${MINGW_PACKAGE_PREFIX}-meson"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-pkg-config")
source=("https://github.com/dosbox-staging/dosbox-staging/archive/refs/tags/v${pkgver}.tar.gz")
sha256sums=('2ca69e65e6c181197b63388c60487a3bcea804232a28c44c37704e70d49a0392')

prepare() {
  cd "${srcdir}/${_forkname}-${pkgver}"
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("--buildtype=release")
  else
    extra_config+=("--buildtype=debug")
  fi

  MSYS2_ARG_CONV_EXCL="--prefix=" \
  ${MINGW_PREFIX}/bin/meson \
    --prefix="${MINGW_PREFIX}" \
    --wrap-mode=nodownload \
    --auto-features=enabled \
    "${extra_config[@]}" \
    -Dunit_tests=disabled \
    -Ddefault_library=shared \
    ../${_forkname}-${pkgver}

  ${MINGW_PREFIX}/bin/meson compile
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  ${MINGW_PREFIX}/bin/meson test
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/meson install

  install -Dm644 "${srcdir}/${_forkname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
}
